#debug "Shot ten is being parsed.\n"

#declare BSOD=1;

#include "gulch.inc"

#declare PortX=-x;
#declare PortY=y;
#declare PortZ=-z;
#declare PortL=<0,0,1400>;
#declare PortOpen=1;
#include "port.inc"

#declare PathPts=array[4] {
  <-200,0,-350>,x,
  <-50,0,-500>,vnormalize( x-3*z)
}

#if(Timer>1.499)
  #declare PathPts[2]=<0,0,-50>;
  #declare PathPts[3]=z;
#end

#declare Path=array[2][5]

PrepFullSpline(PathPts,Path)

#local i_M=vdot(Path[0][4],x+y);
#debug concat("Path length ",str(i_M,0,4),"\n")

#local i_I=Transition(i_M,0,0,Timer-.5);

#if (Timer>1.749)
#local i_I=(Timer-1.75)*(Timer-1.75)*350;
#end
#if (Timer>2.749)
#local i_I=(Timer-2.75)*700+350;
#end

#declare BoxerZ=vnormalize(SplineVel(Path,i_I));
#declare BoxerY=y;
#declare BoxerX=vnormalize(vcross(BoxerY,BoxerZ));
#declare BoxerL=SplineLoc(Path,i_I);
#declare BoxerEyeL=<0,150,2000>;
#declare BoxerEyeR=<0,150,2000>;
#declare BoxerHandL=<-15,40,45>;
#declare BoxerHandR=< 15,40,45>;
#declare BoxerWristL=0;
#declare BoxerWristR=0;
#declare BoxerClawL=15;
#declare BoxerClawR=15;
#declare WheelSpin=i_I*360/2/pi/10;
#declare WheelTurn=0;
#if (BoxerL.z>1350) #declare BoxerClip=plane { z,1400 } #end 
#declare DoorOpen=0;
#declare LaserUp=0;
#include "boxer.inc"

#declare RobotZ=-z;
#declare RobotL=<50,0,-500>;
#declare tLT=0;
#declare tRT=0;

#if (Timer>.999)
#declare RobotZ=vrotate(-z,-y*Transition(0,180,0,Timer-1));
#local tLT=Transition(0,-22.5*pi,0,Timer-1);
#local tRT=Transition(0, 22.5*pi,0,Timer-1);
#end

#if (Timer>1.999)

#declare PathPts[0]=<50,0,-500>;
#declare PathPts[1]=z;
#declare PathPts[2]=<0,0,1400>;
#declare PathPts[3]=z;

PrepFullSpline(PathPts,Path)

#local i_I=(Timer-2)*(Timer-2)*350;

#if (Timer>2.999)
#local i_I=(Timer-3)*700+350;
#end
#declare RobotZ=vnormalize(SplineVel(Path,i_I));
#declare RobotL=SplineLoc(Path,i_I);

#local tLT=i_I-pi*22.5;
#local tRT=i_I+pi*22.5;

#end

#declare RobotY=y;
#declare RobotX=vnormalize(vcross(RobotY,RobotZ));
#declare RotLT=tLT*180/pi/5.625/sqrt(2+sqrt(3));
#declare RotRT=tRT*180/pi/5.625/sqrt(2+sqrt(3));
#declare CamLft1=0;
#declare CamSwp1=0;
#declare CamLft2=15;
#declare CamSwp2=0;
#declare CamLft3=15;
#declare CamSwp3=-180;
#declare BotHandDir=z;
#declare BotHandLoc=<0,100,25>;
#declare ClawOpen=5;
#if (RobotL.z>1366) #declare RustyClip=plane { z,1400 } #end 
#include "rusty.inc"

#declare CamE=Transition(<-50,50,-500>,BoxerL+y*50,0,(Timer-1.5)/1.5);
#declare CamL=<-400,150,-200>+y*Timer;

//#declare CamE=<0,62,1400>;
//#declare CamL=<0,162,900>;
