#declare Hands=array[4] { 0,0,0,0 }

SmoothSeed(Hands,2)

#declare BugPath=array[4]
#declare BugGo=array[2][5]

#local i_I=0; #while (i_I<7)

#switch(i_I)
  #case(0)
//#debug "First bug.\n"
    #declare BugPath[0]=<0,0,-500>-vnormalize(<-1,0,-4>)*880;
    #declare BugPath[1]=-z;
    #declare BugPath[2]=<0,0,-500>-vnormalize(<-2,0,-3>)*280;
    #declare BugPath[3]=vnormalize(<-2,0,-3>);
    #declare Skin0=.5;
    #declare Skin1=.5;
    #local tOff=0;
  #break
  #case(1)
//#debug "Second bug.\n"
    #declare BugPath[0]=<0,0,-500>-vnormalize(< 0,0,-1>)*880;
    #declare BugPath[1]=vnormalize(< 0,0,-1>);
    #declare BugPath[2]=<0,0,-500>-vnormalize(< 0,0,-1>)*280;
    #declare BugPath[3]=vnormalize(< 0,0,-1>);
    #declare Skin0=.25;
    #declare Skin1=.25;
    #local tOff=4/7;
  #break
  #case(2)
//#debug "Third bug.\n"
    #declare BugPath[0]=<0,0,-500>-vnormalize(<-2,0,-1>)*880;
    #declare BugPath[1]=vnormalize(<-2,0,-1>);
    #declare BugPath[2]=<0,0,-500>-vnormalize(<-2,0,-1>)*280;
    #declare BugPath[3]=vnormalize(<-2,0,-1>);
    #declare Skin0=.75;
    #declare Skin1=.75;
    #local tOff=1/7;
  #break
  #case(3)
//#debug "Fourth bug.\n"
    #declare BugPath[0]=<0,0,-500>-vnormalize(<-4,0, 1>)*880;
    #declare BugPath[1]=vnormalize(<-4,0, 1>);
    #declare BugPath[2]=<0,0,-500>-vnormalize(<-4,0, 1>)*280;
    #declare BugPath[3]=vnormalize(<-4,0, 1>);
    #declare Skin0=.125;
    #declare Skin1=.125;
    #local tOff=5/7;
  #break
  #case(4)
//#debug "Fifth bug.\n"
    #declare BugPath[0]=<0,0,-500>-vnormalize(< 5,0,-4>)*880;
    #declare BugPath[1]=vnormalize(< 1,0,-1>);
    #declare BugPath[2]=<0,0,-500>-vnormalize(< 5,0,-2>)*280;
    #declare BugPath[3]=vnormalize(< 5,0,-2>);
    #declare Skin0=.375;
    #declare Skin1=.375;
    #local tOff=2/7;
  #break
  #case(5)
//#debug "Sixth bug.\n"
    #declare BugPath[0]=<0,0,-500>-vnormalize(< 8,0, 1>)*880;
    #declare BugPath[1]=vnormalize(< 8,0,-1>);
    #declare BugPath[2]=<0,0,-500>-vnormalize(< 4,0, 1>)*280;
    #declare BugPath[3]=vnormalize(< 4,0, 1>);
    #declare Skin0=.625;
    #declare Skin1=.625;
    #local tOff=6/7;
  #break
  #case(6)
//#debug "Seventh bug.\n"
    #declare BugPath[0]=<0,0,-500>-vnormalize(< 2,0,-5>)*880;
    #declare BugPath[1]=vnormalize(< 1,0,-5>);
    #declare BugPath[2]=<0,0,-500>-vnormalize(< 4,0,-5>)*280;
    #declare BugPath[3]=vnormalize(< 4,0,-5>);
    #declare Skin0=.875;
    #declare Skin1=.875;
    #local tOff=3/7;
  #break
#end

PrepFullSpline(BugPath,BugGo)

//#debug "Path length="
//#debug str(vdot(BugGo[0][4],x+y),0,3)
//#debug"\n"

#declare GrebGaze=<0,75,-500>;
#declare FingerL=<-16,26,51>
  +<SmoothRand(Hands),SmoothRand(Hands),SmoothRand(Hands)>*<-8,19,21>;
#declare FingerR=< 16,26,51>
  +<SmoothRand(Hands),SmoothRand(Hands),SmoothRand(Hands)>*< 8,19,21>;

#declare BodyRise=
  <SmoothRand(Hands)-.5,SmoothRand(Hands),SmoothRand(Hands)-.5>*<5,10,5>;

#local tTimer=Transition(-4,4,0,(Timer+tOff+4)/8);

// I changed the Walk() macro after rendering this, so it might
// produce the results seen in the published animation.  Sorry.

#local vT=Walk(BugGo,BugGo,tTimer-.125,20,-1e3,640,40,.125,.125,y,<-52.9,0,-40>);
#declare FootLH=vT*<1,0,1>;
#declare LiftLH=vT*<0,1,0>;
#local vT=Walk(BugGo,BugGo,tTimer     , 0,-1e3,640,40,.125,.125,y,< 52.9,0,-40>);
#declare FootRH=vT*<1,0,1>;
#declare LiftRH=vT*<0,1,0>;
#local vT=Walk(BugGo,BugGo,tTimer     , 0,-1e3,640,40,.125,.125,y,<-56.4,0, 40>);
#declare FootLF=vT*<1,0,1>;
#declare LiftLF=vT*<0,1,0>;
#local vT=Walk(BugGo,BugGo,tTimer-.125,20,-1e3,640,40,.125,.125,y,< 56.4,0, 40>);
#declare FootRF=vT*<1,0,1>;
#declare LiftRF=vT*<0,1,0>;

#include "greb.inc"

#local i_I=i_I+1; #end

#declare FingerL=<-16,26,51>;
#declare FingerR=< 16,26,51>;
#declare BodyRise=0*y;

#declare FootLH=<-52.9,0,-40>+<0,40,-1000>;
#declare LiftLH=y*0;
#declare FootRH=< 52.9,0,-40>+<0,40,-1000>;
#declare LiftRH=y*0;
#declare FootLF=<-56.4,0, 40>+<0,40,-1000>;
#declare LiftLF=y*0;
#declare FootRF=< 56.4,0, 40>+<0,40,-1000>;
#declare LiftRF=y*0;
#declare Skin0=0;
#declare Skin1=0;

#include "greb.inc"
